package com.ybchen.shopmanager;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ybchen.shopmanager.mapper.BannerMapper;
import com.ybchen.shopmanager.model.BannerDO;
import com.ybchen.shopmanager.service.BannerService;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

//classes=启动类.class
@SpringBootTest(classes = ShopManagerApplication.class)
@Slf4j
public class BannerTest {
    @Autowired
    private BannerService bannerService;
    @Autowired
    private BannerMapper bannerMapper;

    @Test
    public void testDeleted(){
        int rows = bannerMapper.deleteById(10);
        System.out.println("执行行数："+rows);
    }

    @Test
    public void testUpdate(){
        BannerDO bannerDO=new BannerDO();
        //旧版本号，即查询出来的版本号
        bannerDO.setVersion(1);
        bannerDO.setId(12);
        bannerDO.setUrl("www.baidu.com");
        int rows = bannerMapper.updateById(bannerDO);
        System.out.println("执行行数："+rows);
    }

    @Test
    public void testBannerTest() {
        List<BannerDO> list = bannerService.list();
        log.info("轮播图列表：{}", list);
    }
    @Test
    public void testPage(){
        //第一页，每页3条
        Page<BannerDO> page=new Page<>(2,3);
        IPage<BannerDO> iPage = bannerMapper.selectPage(page, null);
        log.info("总条数：{}",iPage.getTotal());
        log.info("总页数：{}",iPage.getPages());
        log.info("数据：{}",iPage.getRecords());
    }
    @Test
    public void testGetList(){
        List<BannerDO> list = bannerMapper.getList();
        System.out.println("行数："+list.size());
    }
}
